package com.mortals.xhx.daemon.task;

import com.alibaba.fastjson.JSON;
import com.mortals.framework.common.Rest;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.framework.service.ITask;
import com.mortals.framework.service.ITaskExcuteService;
import com.mortals.xhx.base.system.user.model.UserEntity;
import com.mortals.xhx.base.system.user.model.UserQuery;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.common.pdu.RespData;
import com.mortals.xhx.common.pdu.user.UserPdu;
import com.mortals.xhx.common.utils.BeanUtil;
import com.mortals.xhx.common.utils.SyncTreeSiteThread;
import com.mortals.xhx.feign.user.IUserFeign;
import com.mortals.xhx.module.site.service.SiteService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.beanutils.BeanUtilsBean;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;

import java.util.List;

/**
 * 同步用户
 */
@Slf4j
@Service("SyncUserTask")
public class SyncUserTaskImpl implements ITaskExcuteService {

    @Autowired
    private IUserFeign userFeign;
    @Autowired
    private UserService userService;
    @Autowired
    private SiteService siteService;


    @Override
    public void excuteTask(ITask task) throws AppException {

        UserPdu userPdu = new UserPdu();
        userPdu.setPage(1);
        userPdu.setSize(-1);
        Rest<RespData<List<UserPdu>>> list = userFeign.list(userPdu);
        //更新本地用户信息，并且更新用户树
        list.getData().getData().forEach(user -> {
            //查询用户是否存在，
            //UserEntity userEntity = userService.get(user.getId());

            UserEntity userEntity =userService.selectOne(new UserQuery().loginName(user.getLoginName()));

            if (ObjectUtils.isEmpty(userEntity)) {
                //新增
                UserEntity entity = new UserEntity();
                entity.initAttrValue();
                BeanUtils.copyProperties(user, entity, BeanUtil.getNullPropertyNames(user));
                userService.save(entity);
                Context context = new Context();
                context.setUser(userEntity);
                new Thread(new SyncTreeSiteThread(siteService, context)).start();
            }
        });


        // log.info("syncUserResp:{}", JSON.toJSONString(list));

        // return;
//        UserPdu userPdu = new UserPdu();
//        userPdu.setPage(1);
//        userPdu.setSize(-1);
//        String resp = userFeign.findAllUser(userPdu);
//        log.info("resp:{}",resp);
//        JSONObject jsonObject = JSONObject.parseObject(resp);
//        if (jsonObject.getInteger("code") == 1) {
//            List<UserPdu> userList = jsonObject.getJSONObject("data").getObject("data", new TypeReference<List<UserPdu>>() {
//            });
//
//            log.info("userList:{}", JSON.toJSONString(userList));
//
//        }

    }


    @Override
    public void stopTask(ITask task) throws AppException {

    }


}
